within SOFCPoliMi.ParametrizedModels;
model StackSalogniColonna
  extends Components.FuelCell.Stack(
    N = 6,
    redeclare model ReactionRates =
        Components.FuelCell.ChemicalReactions.ChannelReactionRatesAir,
    Eanode = 140e3,
    Ecathode = 1.39e+05,
    kAnode = 6.54e11,
    kCathode = 1e+10,
    porosity = 0.35,
    preExp = 3.34e4,
    constantDiffusion = true,
    T_start = 1173.15,
    cmPEN = 400,
    cmPlate = 500,
    rhoPEN = 6600,
    rhoPlate = 8000,
    X_start_Anode = fill({0.36323, 0.63676, 0, 0, 0, 0, 0, 0, 0, 0.00001}, N + 1),
    X_start_Cathode = fill({0.0, 0.0, 0.0, 0, 0, 0.0, 0.0, 0.205131882988603, 0.794868117011396, 0.0}, N + 1),
    p_start_Anode = ones(N)*101325,
    p_start_Cathode = ones(N)*101325,
    rho_start_Anode = ones(N + 1)*0.03,
    rho_start_Cathode = ones(N + 1)*0.3,
    w_start_Anode = ones(N + 1)*2.79e-6,
    w_start_Cathode = ones(N + 1)*7/4/Modelica.Constants.F/0.21*30*28.9586e-3,
    vLeak0 = 0.035,
    leak = false,
    iPENmax = {1.3792214,1.2731493,1.1541725,1.0373313,0.9256242,0.8208353},
    H = 1e-3,
    W = 0.1,
    totLength = 0.1,
    tauAE = 50e-6,
    tauCE = 50e-6,
    tauSE = 160e-6,
    tauI = 710e-6,
    deltapNomAnode = 100,
    deltapNomCathode = 100);
end StackSalogniColonna;
